searchNodes=[{"type":"module","title":"Multiverses.Presence","doc":"Using Multiverses with Phoenix Presence Since Phoenix Presence is a behaviour module that autogenerates functions for you with its using directive, it is inappropriate to use Multiverses to override Phoenix Presence. Instead, you will have to override the autogenerated module instead. Presuming that you have created a Presence module like so: defmodule MyApp.Presence do use Phoenix.Presence , otp_app : &lt; my_otp_app &gt; , pubsub_server : &lt; my_pubsub_server &gt; end In your test_helpers.exs file (or in a support directory), build the replacement presence module. require Multiverses.Presence Multiverses.Presence . clone ( MyApp.Presence , as : MyApp.Multiverse.Presence ) Now set up your configuration: in config.exs config :my_app , MyApp.Presence , MyApp.Presence in test.exs config :my_app , MyApp.Presence , MyApp.Multiverse.Presence in modules that use presence defmodule MyApp.UsesPresence do @my_app_presence Application . compile_env! ( :my_app , MyApp.Presence ) #... end in your test module defmodule MyAppTest.UsesPresenceTest do use ExUnit.Case , async : true setup do Multiverses . shard ( Phoenix.PubSub ) end end Important Note: The Presence struct will have a :topic key whose value includes the universe postfix. If you're matching against this key, be sure to change your match to be &quot;topic&quot; &lt;&gt; _ instead of &quot;topic&quot;","ref":"Multiverses.Presence.html"},{"type":"macro","title":"Multiverses.Presence.clone/2","doc":"","ref":"Multiverses.Presence.html#clone/2"},{"type":"module","title":"Multiverses.PubSub","doc":"Implements the Multiverses pattern for Phoenix.PubSub . Messages topics are sharded by postfixing the topic with the universe id. Processes in any given universe are then only capable of subscribing to messages sent within the same universe. Don't use this in prod This system should not be used in production to achieve sharding of communications channels. Phoenix channels This does not currently support phoenix channels. PRs or test cases accepted. Recommended Setup in config.exs config :my_app , Phoenix.PubSub , Phoenix.PubSub in test.exs config :my_app , Phoenix.PubSub , Multiverse.PubSub in your pubsub-using modules defmodule MyPubSubModule do @pubsub Application . compile_env! ( :my_app , Phoenix.PubSub ) end in your tests defmodule ModuleThatTestsPubSubTest do use ExUnit.Case , async : true setup do Multiverses . shard ( Phoenix.PubSub ) end end Configuration Many PubSub applications will have subscriber processes that won't be attached to a test, but still need to use the Multiverses.PubSub interface for ad-hoc processes created. In this case, provide the following line in your configuration: Note that the default is to have strict: true in test.exs config :multiverses_pubsub , strict : false Clustering Multiverses.PubSub is tested to work in clustered elixir. Connecting processes to shards over the cluster Note that if a process is running in a peer node, you should provide it with either: the universe id to link it a pid that has been sent over erlang distribution. If you provide a binary serialized pid (via :erlang.term_to_binary/1 ) the rehydrated pid will not be connected to the correct multiverse shard.","ref":"Multiverses.PubSub.html"},{"type":"function","title":"Multiverses.PubSub.broadcast/4","doc":"","ref":"Multiverses.PubSub.html#broadcast/4"},{"type":"function","title":"Multiverses.PubSub.broadcast!/4","doc":"","ref":"Multiverses.PubSub.html#broadcast!/4"},{"type":"function","title":"Multiverses.PubSub.broadcast_from/5","doc":"","ref":"Multiverses.PubSub.html#broadcast_from/5"},{"type":"function","title":"Multiverses.PubSub.broadcast_from!/5","doc":"","ref":"Multiverses.PubSub.html#broadcast_from!/5"},{"type":"function","title":"Multiverses.PubSub.child_spec/1","doc":"See Phoenix.PubSub.child_spec/1 .","ref":"Multiverses.PubSub.html#child_spec/1"},{"type":"function","title":"Multiverses.PubSub.direct_broadcast/5","doc":"","ref":"Multiverses.PubSub.html#direct_broadcast/5"},{"type":"function","title":"Multiverses.PubSub.direct_broadcast!/5","doc":"","ref":"Multiverses.PubSub.html#direct_broadcast!/5"},{"type":"function","title":"Multiverses.PubSub.dispatch/3","doc":"See Phoenix.PubSub.dispatch/3 .","ref":"Multiverses.PubSub.html#dispatch/3"},{"type":"function","title":"Multiverses.PubSub.local_broadcast/4","doc":"","ref":"Multiverses.PubSub.html#local_broadcast/4"},{"type":"function","title":"Multiverses.PubSub.local_broadcast_from/5","doc":"","ref":"Multiverses.PubSub.html#local_broadcast_from/5"},{"type":"function","title":"Multiverses.PubSub.node_name/1","doc":"See Phoenix.PubSub.node_name/1 .","ref":"Multiverses.PubSub.html#node_name/1"},{"type":"function","title":"Multiverses.PubSub.subscribe/3","doc":"","ref":"Multiverses.PubSub.html#subscribe/3"},{"type":"function","title":"Multiverses.PubSub.unsubscribe/2","doc":"","ref":"Multiverses.PubSub.html#unsubscribe/2"},{"type":"module","title":"Multiverses.Tracker","doc":"Using Multiverses With Phoenix Tracker Now set up your configuration: in config.exs config :my_app , Phoenix.PubSub , Phoenix.PubSub config :my_app , Phoenix.Tracker , Phoenix.Tracker in test.exs config :my_app , Phoenix.PubSub , Multiverse.PubSub config :my_app , Phoenix.Tracker , Multiverse.Tracker Create your tracker module As usual, you must implement a a Tracker module. This is an example Tracker module that is a direct reinterpretation of the example Phoenix.Tracker module. If you have your own tracker logic, use that instead. Note that the handle_diff callback will be executed in separate batches, one for each known universe shard. defmodule MyApp.Tracker do use Phoenix.Tracker @phoenix_tracker Application . get_env ( :my_app , Phoenix.Tracker ) @phoenix_pubsub Application . get_env ( :my_app , Phoenix.PubSub ) def start_link ( opts ) do opts = Keyword . merge ( [ name : __MODULE__ ] , opts ) @phoenix_tracker . start_link ( __MODULE__ , opts , opts ) end def init ( opts ) do server = Keyword . fetch! ( opts , :pubsub_server ) { :ok , %{ pubsub_server : server , node_name : Phoenix.PubSub . node_name ( server ) } } end def handle_diff ( diff , state ) do for { topic , { joins , leaves } } &lt;- diff do for { _key , meta } &lt;- joins do @phoenix_pubsub . broadcast ( ... ) end for { _key , meta } &lt;- leaves do @phoenix_pubsub . broadcast ( ... ) end end { :ok , state } end end wherever you use Tracker defmodule MyApp.UsesTracker do # in place of `alias Phoenix.Tracker` @tracker Application . compile_env! ( :my_app , Phoenix.Tracker ) # ... code with @tracker in place of Tracker end","ref":"Multiverses.Tracker.html"},{"type":"function","title":"Multiverses.Tracker.child_spec/1","doc":"See Phoenix.Tracker.child_spec/1 .","ref":"Multiverses.Tracker.html#child_spec/1"},{"type":"function","title":"Multiverses.Tracker.get_by_key/3","doc":"","ref":"Multiverses.Tracker.html#get_by_key/3"},{"type":"function","title":"Multiverses.Tracker.graceful_permdown/1","doc":"See Phoenix.Tracker.graceful_permdown/1 .","ref":"Multiverses.Tracker.html#graceful_permdown/1"},{"type":"function","title":"Multiverses.Tracker.handle_diff/2","doc":"","ref":"Multiverses.Tracker.html#handle_diff/2"},{"type":"function","title":"Multiverses.Tracker.handle_info/2","doc":"","ref":"Multiverses.Tracker.html#handle_info/2"},{"type":"function","title":"Multiverses.Tracker.init/1","doc":"","ref":"Multiverses.Tracker.html#init/1"},{"type":"function","title":"Multiverses.Tracker.list/2","doc":"","ref":"Multiverses.Tracker.html#list/2"},{"type":"function","title":"Multiverses.Tracker.start_link/3","doc":"","ref":"Multiverses.Tracker.html#start_link/3"},{"type":"function","title":"Multiverses.Tracker.track/5","doc":"","ref":"Multiverses.Tracker.html#track/5"},{"type":"function","title":"Multiverses.Tracker.untrack/2","doc":"See Phoenix.Tracker.untrack/2 .","ref":"Multiverses.Tracker.html#untrack/2"},{"type":"function","title":"Multiverses.Tracker.untrack/4","doc":"","ref":"Multiverses.Tracker.html#untrack/4"},{"type":"function","title":"Multiverses.Tracker.update/5","doc":"","ref":"Multiverses.Tracker.html#update/5"},{"type":"extras","title":"Multiverses.PubSub","doc":"Multiverses support for Phoenix PubSub","ref":"readme.html"},{"type":"extras","title":"Multiverses.PubSub - Installation","doc":"The package can be installed by adding multiverses_pubsub to your list of dependencies in mix.exs : def deps do [ { :multiverses , &quot;~&gt; 0.9&quot; , only : :test } , { :multiverses_pubsub , &quot;~&gt; 0.3.0&quot; , only : :test } ] end Docs can be found at https://hexdocs.pm/multiverses_pubsub .","ref":"readme.html#installation"},{"type":"extras","title":"Multiverses.PubSub - Testing","doc":"This library allows parallel testing: REPLICATION = 10 mix test","ref":"readme.html#testing"}]